<a id="mypy-boto3-lakeformation"></a>

# mypy-boto3-lakeformation

[![PyPI - types-aiobotocore-lakeformation](https://img.shields.io/pypi/v/types-aiobotocore-lakeformation.svg?color=blue)](https://pypi.org/project/types-aiobotocore-lakeformation)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-lakeformation.svg?color=blue)](https://pypi.org/project/types-aiobotocore-lakeformation)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-lakeformation?color=blue)](https://pypistats.org/packages/types-aiobotocore-lakeformation)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.LakeFormation 1.20.47](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/lakeformation.html#LakeFormation)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[types-aiobotocore-lakeformation docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_lakeformation/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-lakeformation](#mypy-boto3-lakeformation)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `LakeFormation`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `LakeFormation` service.

```bash
python -m pip install types-aiobotocore[lakeformation]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[lakeformation]` in your environment:
  `python -m pip install 'types-aiobotocore[lakeformation]'`

Both type checking and auto-complete should work for `LakeFormation` service.
No explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `types-aiobotocore[lakeformation]` in your environment:
  `python -m pip install 'types-aiobotocore[lakeformation]'`

Both type checking and auto-complete should work for `LakeFormation` service.
No explicit type annotations required, write your `aiobotocore` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`types-aiobotocore` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[lakeformation]` in your environment:
  `python -m pip install 'types-aiobotocore[lakeformation]'`
- Run `mypy` as usual

Type checking should work for `LakeFormation` service. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `types-aiobotocore[lakeformation]` in your environment:
  `python -m pip install 'types-aiobotocore[lakeformation]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `LakeFormation` service. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`LakeFormationClient` provides annotations for
`session.create_client("lakeformation")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_lakeformation import LakeFormationClient

session = get_session()
with async session.create_client("lakeformation") as client:
    client: LakeFormationClient
    # now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_lakeformation.paginator` module contains type annotations
for all paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_lakeformation import LakeFormationClient
from types_aiobotocore_lakeformation.paginator import (
    GetWorkUnitsPaginator,
    ListDataCellsFilterPaginator,
    ListLFTagsPaginator,
    SearchDatabasesByLFTagsPaginator,
    SearchTablesByLFTagsPaginator,
)

session = get_session()
with async session.create_client("lakeformation") as client:
    client: LakeFormationClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        get_work_units_paginator: GetWorkUnitsPaginator = client.get_paginator("get_work_units")
        list_data_cells_filter_paginator: ListDataCellsFilterPaginator = client.get_paginator("list_data_cells_filter")
        list_lf_tags_paginator: ListLFTagsPaginator = client.get_paginator("list_lf_tags")
        search_databases_by_lf_tags_paginator: SearchDatabasesByLFTagsPaginator = client.get_paginator("search_databases_by_lf_tags")
        search_tables_by_lf_tags_paginator: SearchTablesByLFTagsPaginator = client.get_paginator("search_tables_by_lf_tags")
    ```







### Literals

`types_aiobotocore_lakeformation.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_lakeformation.literals import (
    ComparisonOperatorType,
    DataLakeResourceTypeType,
    FieldNameStringType,
    GetWorkUnitsPaginatorName,
    ListDataCellsFilterPaginatorName,
    ListLFTagsPaginatorName,
    OptimizerTypeType,
    PermissionType,
    QueryStateStringType,
    ResourceShareTypeType,
    ResourceTypeType,
    SearchDatabasesByLFTagsPaginatorName,
    SearchTablesByLFTagsPaginatorName,
    TransactionStatusFilterType,
    TransactionStatusType,
    TransactionTypeType,
    ServiceName,
    PaginatorName,
)

def check_value(value: ComparisonOperatorType) -> bool:
    ...
````

### Typed dictionaries

`types_aiobotocore_lakeformation.type_defs` module contains structures and
shapes assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_lakeformation.type_defs import (
    AddLFTagsToResourceRequestRequestTypeDef,
    AddLFTagsToResourceResponseTypeDef,
    AddObjectInputTypeDef,
    BatchGrantPermissionsRequestRequestTypeDef,
    BatchGrantPermissionsResponseTypeDef,
    BatchPermissionsFailureEntryTypeDef,
    BatchPermissionsRequestEntryTypeDef,
    BatchRevokePermissionsRequestRequestTypeDef,
    BatchRevokePermissionsResponseTypeDef,
    CancelTransactionRequestRequestTypeDef,
    ColumnLFTagTypeDef,
    ColumnWildcardTypeDef,
    CommitTransactionRequestRequestTypeDef,
    CommitTransactionResponseTypeDef,
    CreateDataCellsFilterRequestRequestTypeDef,
    CreateLFTagRequestRequestTypeDef,
    DataCellsFilterResourceTypeDef,
    DataCellsFilterTypeDef,
    DataLakePrincipalTypeDef,
    DataLakeSettingsTypeDef,
    DataLocationResourceTypeDef,
    DatabaseResourceTypeDef,
    DeleteDataCellsFilterRequestRequestTypeDef,
    DeleteLFTagRequestRequestTypeDef,
    DeleteObjectInputTypeDef,
    DeleteObjectsOnCancelRequestRequestTypeDef,
    DeregisterResourceRequestRequestTypeDef,
    DescribeResourceRequestRequestTypeDef,
    DescribeResourceResponseTypeDef,
    DescribeTransactionRequestRequestTypeDef,
    DescribeTransactionResponseTypeDef,
    DetailsMapTypeDef,
    ErrorDetailTypeDef,
    ExecutionStatisticsTypeDef,
    ExtendTransactionRequestRequestTypeDef,
    FilterConditionTypeDef,
    GetDataLakeSettingsRequestRequestTypeDef,
    GetDataLakeSettingsResponseTypeDef,
    GetEffectivePermissionsForPathRequestRequestTypeDef,
    GetEffectivePermissionsForPathResponseTypeDef,
    GetLFTagRequestRequestTypeDef,
    GetLFTagResponseTypeDef,
    GetQueryStateRequestRequestTypeDef,
    GetQueryStateResponseTypeDef,
    GetQueryStatisticsRequestRequestTypeDef,
    GetQueryStatisticsResponseTypeDef,
    GetResourceLFTagsRequestRequestTypeDef,
    GetResourceLFTagsResponseTypeDef,
    GetTableObjectsRequestRequestTypeDef,
    GetTableObjectsResponseTypeDef,
    GetWorkUnitResultsRequestRequestTypeDef,
    GetWorkUnitResultsResponseTypeDef,
    GetWorkUnitsRequestRequestTypeDef,
    GetWorkUnitsResponseTypeDef,
    GrantPermissionsRequestRequestTypeDef,
    LFTagErrorTypeDef,
    LFTagKeyResourceTypeDef,
    LFTagPairTypeDef,
    LFTagPolicyResourceTypeDef,
    LFTagTypeDef,
    ListDataCellsFilterRequestRequestTypeDef,
    ListDataCellsFilterResponseTypeDef,
    ListLFTagsRequestRequestTypeDef,
    ListLFTagsResponseTypeDef,
    ListPermissionsRequestRequestTypeDef,
    ListPermissionsResponseTypeDef,
    ListResourcesRequestRequestTypeDef,
    ListResourcesResponseTypeDef,
    ListTableStorageOptimizersRequestRequestTypeDef,
    ListTableStorageOptimizersResponseTypeDef,
    ListTransactionsRequestRequestTypeDef,
    ListTransactionsResponseTypeDef,
    PaginatorConfigTypeDef,
    PartitionObjectsTypeDef,
    PlanningStatisticsTypeDef,
    PrincipalPermissionsTypeDef,
    PrincipalResourcePermissionsTypeDef,
    PutDataLakeSettingsRequestRequestTypeDef,
    QueryPlanningContextTypeDef,
    RegisterResourceRequestRequestTypeDef,
    RemoveLFTagsFromResourceRequestRequestTypeDef,
    RemoveLFTagsFromResourceResponseTypeDef,
    ResourceInfoTypeDef,
    ResourceTypeDef,
    ResponseMetadataTypeDef,
    RevokePermissionsRequestRequestTypeDef,
    RowFilterTypeDef,
    SearchDatabasesByLFTagsRequestRequestTypeDef,
    SearchDatabasesByLFTagsResponseTypeDef,
    SearchTablesByLFTagsRequestRequestTypeDef,
    SearchTablesByLFTagsResponseTypeDef,
    StartQueryPlanningRequestRequestTypeDef,
    StartQueryPlanningResponseTypeDef,
    StartTransactionRequestRequestTypeDef,
    StartTransactionResponseTypeDef,
    StorageOptimizerTypeDef,
    TableObjectTypeDef,
    TableResourceTypeDef,
    TableWithColumnsResourceTypeDef,
    TaggedDatabaseTypeDef,
    TaggedTableTypeDef,
    TransactionDescriptionTypeDef,
    UpdateLFTagRequestRequestTypeDef,
    UpdateResourceRequestRequestTypeDef,
    UpdateTableObjectsRequestRequestTypeDef,
    UpdateTableStorageOptimizerRequestRequestTypeDef,
    UpdateTableStorageOptimizerResponseTypeDef,
    VirtualObjectTypeDef,
    WorkUnitRangeTypeDef,
    WriteOperationTypeDef,
)

def get_structure() -> AddLFTagsToResourceRequestRequestTypeDef:
    return {
      ...
    }
```

## Versioning

`types-aiobotocore-lakeformation` version is the same as related `boto3`
version and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/)
format.

## Documentation

All type annotations can be found in
[types-aiobotocore-lakeformation docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_lakeformation/)

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
